global mov_all_bytes_asm
global nop_all_bytes_asm
global nop_1x3_all_bytes_asm
global nop_1x9_all_bytes_asm
global inc_all_bytes_asm
global dec_all_bytes_asm
global align64_loop
global align1_loop
global align15_loop
global align31_loop
global align63_loop
global align75_loop
global align90_loop
global align112_loop

mov_all_bytes_asm:
	xor rax, rax

	.loop:
		mov BYTE [rdi + rax * 1], al
		inc rax
		cmp rsi, rax
		jne .loop

	ret

nop_all_bytes_asm:
	xor rax, rax

	.loop:
		db 0x0f, 0x1f, 0x00
		inc rax
		cmp rdi, rax
		jne .loop

	ret

nop_1x3_all_bytes_asm:
	xor rax, rax

	.loop:
		nop
		nop
		nop
		inc rax
		cmp rdi, rax
		jne .loop

	ret

nop_1x9_all_bytes_asm:
	xor rax, rax

	.loop:
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		nop
		inc rax
		cmp rdi, rax
		jne .loop

	ret

inc_all_bytes_asm:
	xor rax, rax

	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

dec_all_bytes_asm:
	.loop:
		dec rdi
		jnz .loop

	ret

align64_loop:
	xor rax, rax

	align 64
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align1_loop:
	xor rax, rax

	align 64
	nop
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align15_loop:
	xor rax, rax

	align 64
	%rep 15
	nop
	%endrep
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align31_loop:
	xor rax, rax

	align 64
	%rep 31
	nop
	%endrep
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align63_loop:
	xor rax, rax

	align 64
	%rep 63
	nop
	%endrep
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align75_loop:
	xor rax, rax

	align 64
	%rep 75
	nop
	%endrep
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align90_loop:
	xor rax, rax

	align 64
	%rep 90
	nop
	%endrep
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret

align112_loop:
	xor rax, rax

	align 64
	%rep 112
	nop
	%endrep
	.loop:
		inc rax
		cmp rdi, rax
		jne .loop

	ret
